
///////////////////////////////////////////////////////////////////////////
// This program is free software: you can redistribute it and/or modify  //
// it under the terms of the version 3 of the GNU General Public License //
// as published by the Free Software Foundation.                         //
//                                                                       //
// This program is distributed in the hope that it will be useful, but   //
// WITHOUT ANY WARRANTY; without even the implied warranty of            //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      //
// General Public License for more details.                              //
//                                                                       //
// You should have received a copy of the GNU General Public License     //
// along with this program. If not, see <http://www.gnu.org/licenses/>.  //
//                                                                       //
// Written by Francois Fleuret, (C) IDIAP                                //
// Contact <francois.fleuret@idiap.ch> for comments & bug reports        //
///////////////////////////////////////////////////////////////////////////

#ifndef POSE_H
#define POSE_H

#include "rgb_image.h"
#include "image.h"

class Pose {
public:
  scalar_t _bounding_box_xmin, _bounding_box_ymin;
  scalar_t _bounding_box_xmax, _bounding_box_ymax;
  scalar_t _head_xc, _head_yc, _head_radius;
  scalar_t _belly_xc, _belly_yc;

  Pose();

  bool hit(int level, Pose *pose);
  bool collide(int level, Pose *pose);

  void horizontal_flip(scalar_t scene_width);
  void translate(scalar_t dx, scalar_t dy);
  void scale(scalar_t factor);

  void draw(int thickness, int r, int g, int b, int level, RGBImage *image);

  void print(ostream *out);

  void write(ostream *out);
  void read(istream *in);
};

#endif
